<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8 content=" width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css">
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js"></script>

</head>

<body>
    <div class="container">
        <h2 class="form-group">Province</h2>
        <div class="row container jumbotron">
            <div class="col-sm-6">
                <div class="row form-group">
                    <div class="col-sm-6">
                        <label for="">Tỉnh thành phố</label>
                    </div>
                    <div class="col-sm-6">
                        <select name="" id="select-province" class="form-control"></select>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-6">
                        <label for="">Quận huyện</label>
                    </div>
                    <div class="col-sm-6">
                        <select name="" id="select-district" class="form-control"></select>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-6">
                        <label for="">Phường xã</label>
                    </div>
                    <div class="col-sm-6">
                        <select name="" id="select-ward" class="form-control"></select>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <script>

        var gDisstricts = [];
        //cal api get data province
        $.ajax({
            url: "http://localhost:8080/province5",
            type: "GET",
            success: function (res) {
                console.log(res.content)
                loadDataToSelectProvinces(res.content)
            },
            error: function (err) {
                console.log(err.status)
            }
        })

         //load data to select province
        var gProvinceSelectElement = $("#select-province");
       
        function loadDataToSelectProvinces(paramRes) {
            for (i = 0; i < paramRes.length; i++) {
                let bOption = $("<option>", {
                    value: paramRes[i].code,
                    text: paramRes[i].name
                }).appendTo(gProvinceSelectElement);
            }
            return gProvinceSelectElement;
        }

        //call back function
        var gDistrictSelectElement = $("#select-district")
        gProvinceSelectElement.on("change", function () {
            gDistrictSelectElement.html("");
            var bProvince = $(this).val();
            getDistrictByProvinceCode(bProvince);
        })

        //call api get data district
        function getDistrictByProvinceCode(paramProvinceCode) {
    
            $.ajax({
                url: "http://localhost:8080/districts?code=" + paramProvinceCode,
                type: "GET",
                success: function (res) {
                    gDisstricts = res;
                    console.log(gDisstricts);
                    loadDataToSelectDisstrict(res);
                },
                error: function (err) {
                    console.log(err.status);
                }
            })
        }

        //load dato to select district
        function loadDataToSelectDisstrict(paramRes) {
            for(i = 0; i < paramRes.length; i++) {
                $("<option>", {
                    value: paramRes[i].code,
                    text: paramRes[i].name
                }).appendTo(gDistrictSelectElement);
            }
        }

        var gWardSelectElement = $("#select-ward")
        gDistrictSelectElement.on("change", function() {
            gWardSelectElement.html("");
            var vDistrict = $(this).val();
            var selectedDistrictObj = gDisstricts.find(function(gDisstricts) {
                return gDisstricts.name === vDistrict;
            });
            if (selectedDistrictObj) {
                var selectedDistrictId = selectedDistrictObj.id;
                getWard(selectedDistrictId);
            }
        })

        //call api get ward
        function getWard(paramDistrict) {
            $.ajax({
                url: "http://localhost:8080/wards?id=" + paramDistrict,
                type: "GET",
                success: function(res) {
                    console.log(res);
                    loadDataToSelectWard(res);
                },
                error: function(err) {
                    console.log(err.status);
                }
            })
        }

        //load data to select ward
        function loadDataToSelectWard(paramRes) {
            for(i = 0; i < paramRes.length; i++) {
                $("<option>", {
                    value: paramRes[i].prefix,
                    text:paramRes[i].name
                }).appendTo(gWardSelectElement);
            }
        }
    </script>
</body>

</html>